# This code is part of the 'enjuewemela' game
# License: GPLv3
# Main author: Facundo Batista
# Code, bug tracker, etc:
#   https://launchpad.net/enjuewemela/
#
"""Benchmark for the detector."""

from __future__ import division

import time
import random

from enjuewemela.logic_board import detect

HOW_MANY = 1000

class FakeBoard(object):
    def __init__(self, board):
        self.board = board
        self.height = len(board) - 1

    def get_piece(self, x, y):
        return self.board[self.height-y][x]

    def __len__(self):
        return len(self.board)

def _generate_board():
    board = []
    for i in range(8):
        lin = [random.randint(0,6) for j in range(8)]
        board.append(lin)
    return FakeBoard(board)

scenario = [_generate_board() for x in range(HOW_MANY)]

print "Benchmarking the detector..."
results = {}
tini = time.time()
for board in scenario:
    res = detect(board)
    lenres = len(res)
    results[lenres] = results.get(lenres, 0) + 1
tfin = time.time()

print "    Done! Tested %d iterations" % HOW_MANY
print "    Average analysis time: %.2f mseg" % (1000 * (tfin-tini) / HOW_MANY)
print "    Matchs:", results

