# This code is part of the 'enjuewemela' game
# License: GPLv3
# Main author: Facundo Batista
# Code, bug tracker, etc:
#   https://launchpad.net/enjuewemela/
#
"""Benchmark for the future guesser."""

from __future__ import division

import time

from enjuewemela.logic_board import (
    FakeBoard,
    future_guess,
    generate_nonmatch_board,
)

HOW_MANY = 1000

scenario = [FakeBoard(generate_nonmatch_board()) for x in range(HOW_MANY)]

print "Benchmarking the future guesser..."
with_chance = 0
tini = time.time()
for board in scenario:
    res = future_guess(board)
    if res:
        with_chance += 1
tfin = time.time()

print "    Done! Tested %d iterations" % HOW_MANY
print "    Average analysis time: %.2f mseg" % (1000 * (tfin-tini) / HOW_MANY)
print "    With chance", with_chance
